// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: AVR_com.c
* - ߲		: IAR EWAAVR 4.11a
*
* - xҰ		: avr@atmel.com
*
* - x޲	: UART/USARTS޲gpł܂B
*				  ATmega128pɏĂ܂B
*
* - pLq	: AVR323 - GSMϕ̲̪
*
* - 		: GSMϕ퐧̂߂AT()gp@̗
*
* $Revision: 1.1 $
* $Date: Tuesday, November 08, 2005 12:26:20 UTC $
*****************************************************************************/

// SPLINTɊւĎgp
#ifdef S_SPLINT_S
	#include"splint.h"
#endif

// ݸٰ
#include<iom128.h>
#include<inavr.h>
#include"AVRSMS_com.h"

//! Ɖ׸
int rx_overflow, rx_ack;

//! IɏՕ
static unsigned char rx_buffer[RX_BUFFER_SIZE];

//! Iʒuwq
static unsigned char searchStr;

//! ɏՕv
static int rx_i;

//! ɏՕݎwW
static int rx_wr_i;

//! 񌟍(searchStr)ɂĎw邱Ƃ\ȕ
const unsigned char __flash OK[]				= "OK\r\n";					//!< "OK"
const unsigned char __flash CMTI[]				= "+CMTI: ";				//!< VKүޓ
const unsigned char __flash READY[]				= "> ";						//!< db@үގM
const unsigned char __flash CR_LF[]				= "\r\n";					//!< As
const unsigned char __flash *searchFor;										//!< ׯ ؈ʒuwq
const unsigned char __flash *searchStrings[4]	= {OK, CMTI, READY, CR_LF};	//!< ʒuwq

/*! \brief USART0
 *
 * ̊֐USART0̐ްڰĂƋ@\ݒ肵܂B葽̏ڍׂɂĂ
 * ްĂB
 *
 * \param	input	]ްڰ(ްĎQ)
 *
 * \retval	Ȃ
 */
void COM_init( unsigned int baudrate )
{
	UBRR0H = (unsigned char) (baudrate>>8);							// ްڰĐݒ
	UBRR0L = (unsigned char) baudrate;
	UCSR0B = ( 1 << RXEN0 ) | ( 1 << TXEN0 );						// M,M
	UCSR0C = ( 1 << USBS0 ) | ( 1 << UCSZ01 ) | ( 1 << UCSZ00 );	// 8ޯ ް,1~ޯĂݒ(葽̏ɂްĂB)
	COM_rx_reset();													// MɏՕ̑ؾ
}

/*! \brief M荞ؾ
 *
 * \param	Ȃ
 *
 * \retval	Ȃ
 */
void COM_rx_reset( void )
{
	UCSR0B &= ~(1<<RXCIE0);			// M荞݋֎~
	rx_i = rx_wr_i = 0;				// ֌Wϐ
	rx_overflow = rx_ack = 0;		// ׸ޑ
	rx_buffer[ rx_wr_i ] = '\0';	// MɏՕ
}

/*! \brief M荞݋
 *
 * \param	Ȃ
 *
 * \retval	Ȃ
 */
void COM_rx_on( void )
{
	UCSR0B |= ( 1 << RXCIE0 );		// M荞݋
}

/*! \brief M荞݋֎~
 *
 * \param	Ȃ
 *
 * \retval	Ȃ
 */
void COM_rx_off( void )
{
	UCSR0B &= ~( 1 << RXCIE0 );		// M荞݋֎~
}

/*! \brief ]ތݒ
 *
 * \param	Ȃ
 *
 * \retval	Ȃ
 */
void COM_setSearchString( unsigned char Response )
{
	UCSR0B &= ~( 1 << RXCIE0 );				// M荞݋֎~
	searchFor = searchStrings[Response];	// ]ތݒ
	searchStr = Response;					// rx_isrŎgp
	rx_i = 0;								// MɏՕv평
}

/*! \brief M荞ٰ
 *
 * ̎Mٰ݂͐ڑϕ킩痈үނɏՂ܂AM񂪉ꂽׂ܂B
 */
#pragma vector=USART0_RXC_vect
__interrupt void USART0_RX_interrupt( void )
{
	unsigned char data;								// Ǐϐ

	data = UDR0;									// M޲Ď擾
	rx_buffer[ rx_wr_i++ ] = data;                  // Vް ޲ĂɏՕɊi[
	if( rx_wr_i > RX_BUFFER_MASK )                  // ꌟAŁA
	{
		rx_wr_i = 0;								// ݎwWؾ
		rx_overflow = 1;							// ׸ސݒ
		UCSR0B &= ~( 1 << RXCIE0 );					// M荞݋֎~
	}
	if( searchFor[rx_i] == data )					// vAvŁA
	{
		rx_i++;										// ɏՕvis(+1)
		if( !searchFor[rx_i] )						// Vүޕ̍ŌŁA
		{
			rx_i = 0;								// ɏՕv평
			if( searchStr == CMTI_ )                // +CMTI:ALŁA
			{
				searchFor = searchStrings[ CRLF_ ];	// Iqݒ
				searchStr = CRLF_;					// Iqҋ@
			}
			else									// WŁA
			{
				rx_ack = 1;							// VKү ׸ސݒ
				UCSR0B &= ~( 1 << RXCIE0 );			// M荞݋֎~
			}
		}
	}
	else											// svŁA
	{
		rx_i = 0;									// ɏՕv평(Č)
	}
}

/*! \brief putchar@(荞݋쓮Msv)
 *
 * ANSI C putchar()@̉
 *
 * \param	data	M
 *
 * \retval	data	
 * \retval	-1		Ԓ
 */
int COM_putchar( unsigned char data )
{
	// Ǐϐ
	unsigned int i;

	for( i = 0; !( UCSR0A & ( 1 << UDRE0 ) ); i++ )	// MɏՕ󂫑ҋ@
	{
		if( i > RX_WAIT )							// ҂Ԓ߂ŁA
		{
			return -1;								// ԒߕƋɕA
		}
	}
	UDR0 = data;									// ޲đMJn
	return (int)data;								// (Ml)ƋɕA
}

/*! \brief ̕@͐^}10^5-1͈̔͂ŏo͂܂B
 *
 * \param	i	oׂ͂
 *
 * \retval	Ȃ
 */
void COM_put_integer( int i )
{
	//! Ǐϐ
	int ii;
	unsigned char int_buf[5];

	if (i < 0)												// ŁA
	{
		i = -i;												// ɕϊ
		COM_putchar('-');									// "-"o
	}
	for (ii=0; ii < 5; )									// ^z֐ϊ(ʌ)
	{
		int_buf[ii++] = '0'+ i % 10;						// Ήl擾/i[
		i = i / 10;                                         // l10
	}
	do{ ii--; }while( (int_buf[ii] == '0') && (ii != 0) );	// s"0"폜
	do{ COM_putchar( int_buf[ii--] ); }while (ii >= 0);		// ϊ㕶zo
}

/*! \brief Ȃcharo
 *
 * \param	str		ւ̈ʒuwq
 *
 * \retval	Ȃ
 */
void COM_puts(unsigned char *str)
{
	for( ;*str != '\0'; )		// Iq܂Ōp
	{
		COM_putchar( *str++ );	// Ήo
	}
}

/*! \brief ׯ ؏̕ȂcharŒ蕶o
 *
 * \param	fstr	ւ̈ʒuwq
 *
 * \retval	Ȃ
 */
void COM_putsf( const unsigned char __flash *fstr )
{
	for( ;*fstr != '\0'; )		// Iq܂Ōp
	{
		COM_putchar( *fstr++ );	// Ήo
	}
}

/*! \brief sO,K,\r,\n폜
 *
 * MɏՕ"OK\r\n"ꍇA̕폜܂B
 *
 * \param	Ȃ
 *
 * \retval	i	؂藎ƂɏՕ̒
 */
int COM_trim( void )
{
	//! Ǐϐ
	int i;
	unsigned char temp;

	for( i = rx_wr_i - 1; i >= 0; i--)														// ɏՕLŠ(Ō)
	{
		temp = rx_buffer[i];																// MɏՕΉ擾
		if( ( temp != '\r' ) && ( temp != '\n' ) && ( temp != 'O' ) && ( temp != 'K' ) )	// 'O','K','\r','\n'ȊOȂA
		{
			break;																			// I
		}
	}
	rx_buffer[ i+1 ] = '\0';																// ŏIΏە̎ɏIqݒ
	return i;																				// ̒ƋɕA
}

/*! \brief MɏՕւ̈ʒuwqԂ܂B
 *
 * \param	Ȃ
 *
 * \retval	rx_buffer	MɏՕւ̈ʒuwq
 */
unsigned char* COM_gets( void )
{
	return rx_buffer;	// MɏՕ擪ʒuƋɕA
}
